;-----------------------------------------------------------------------------
;* LCD-Testprogramm fuer AVR-Assembler (avra)      letzte Aenderung: 16.9.2010
;* Version: 0.0
;* Prozessor: Atmega8
;* Schaltschema: PortD obere 6 Bits am LCD-Modul angeschlossen
;* Autor: Rolf Pfister
;* Copyright: Freeware
;* History:
;* 16.9.2010	Erstellung
;*
;-----------------------------------------------------------------------------
.equ F_CPU = 8000000	; Quarzfrequenz in Herz
.include "m8def.inc" 	; Definitionsdatei fuer den Prozessortyp

; Reset und Interruptvectoren	;VNr. Beschreibung
begin:	rjmp	main		; 1   Power On Reset
	reti			; 2   Int0-Interrupt
	reti			; 3   Int1-Interrupt
	reti			; 4   TC2 Compare Match
	reti			; 5   TC2 Overflow
	reti			; 6   TC1 Capture
	reti			; 7   TC1 Compare Match A
	reti			; 8   TC1 Compare Match B
	reti			; 9   TC1 Overflow
	reti			; 10  TC0 Overflow
	reti			; 11  SPI, STC = Serial Transfer Complete
	reti			; 12  UART Rx Complete
	reti			; 13  UART Data Register Empty
	reti			; 14  UART Tx Complete
	reti			; 15  ADC Conversion Complete
	reti			; 16  EEPROM ready
	reti			; 17  Analog Comperator
	reti			; 18  TWI (I2C) Serial Interface
	reti			; 19  Store Program Memory ready
;-----------------------------------------------------------------------------
	.include "lcdmodul.asm"
;-----------------------------------------------------------------------------
; Start, Power On, Reset
main:	ldi r16, low(RAMEND)
        out SPL, r16  	     ; Init Stackpointer L
	ldi r16, high(RAMEND)
        out SPH, r16  	     ; Init Stackpointer H

;; Init-Code
	rcall lcd_init

;-----------------------------------------------------------------------------
;; Hauptprogramm
	ldi r16, 'T'
	rcall lcd_write
	ldi r16, 'e'
	rcall lcd_write
	ldi r16, 'x'
	rcall lcd_write
	ldi r16, 't'
	rcall lcd_write

	ldi r16, 0x21		; 2.Zeile 1.Zeichen
	rcall lcd_go

	ldi ZL, low(hello<<1)
	ldi ZH, high(hello<<1)
	rcall print_string

mainloop:
	rjmp mainloop

hello:	.db "Hello World!",0,0
